import { renderless, api } from "@xmweb-ui/vue-renderless/autocomplete/vue";
import { defineComponent, directive, props, setup as _setup } from "@xmweb-ui/vue-common";
import Scrollbar from "@xmweb-ui/vue-scrollbar";
import Input from "@xmweb-ui/vue-input";
import Clickoutside from "@xmweb-ui/vue-renderless/common/deps/clickoutside";
import { iconLoading } from "@xmweb-ui/vue-icon";
function normalizeComponent(scriptExports, render, staticRenderFns, functionalTemplate, injectStyles, scopeId, moduleIdentifier, shadowMode) {
  var options = typeof scriptExports === "function" ? scriptExports.options : scriptExports;
  if (render) {
    options.render = render;
    options.staticRenderFns = staticRenderFns;
    options._compiled = true;
  }
  if (functionalTemplate) {
    options.functional = true;
  }
  if (scopeId) {
    options._scopeId = "data-v-" + scopeId;
  }
  var hook;
  if (moduleIdentifier) {
    hook = function hook2(context) {
      context = context || // cached call
      this.$vnode && this.$vnode.ssrContext || // stateful
      this.parent && this.parent.$vnode && this.parent.$vnode.ssrContext;
      if (!context && typeof __VUE_SSR_CONTEXT__ !== "undefined") {
        context = __VUE_SSR_CONTEXT__;
      }
      if (injectStyles) {
        injectStyles.call(this, context);
      }
      if (context && context._registeredComponents) {
        context._registeredComponents.add(moduleIdentifier);
      }
    };
    options._ssrRegister = hook;
  } else if (injectStyles) {
    hook = shadowMode ? function() {
      injectStyles.call(this, (options.functional ? this.parent : this).$root.$options.shadowRoot);
    } : injectStyles;
  }
  if (hook) {
    if (options.functional) {
      options._injectStyles = hook;
      var originalRender = options.render;
      options.render = function renderWithStyleInjection(h, context) {
        hook.call(context);
        return originalRender(h, context);
      };
    } else {
      var existing = options.beforeCreate;
      options.beforeCreate = existing ? [].concat(existing, hook) : [hook];
    }
  }
  return {
    exports: scriptExports,
    options
  };
}

var __vue2_script = defineComponent({
  components: {
    XmInput: Input,
    XmScrollbar: Scrollbar,
    IconLoading: iconLoading()
  },
  directives: directive({
    Clickoutside
  }),
  props: [].concat(props, ["valueKey", "popperClass", "tabindex", "popperOptions", "placeholder", "clearable", "disabled", "name", "size", "modelValue", "maxlength", "minlength", "autofocus", "fetchSuggestions", "triggerOnFocus", "customItem", "selectWhenUnmatched", "prefixIcon", "suffixIcon", "label", "debounce", "placement", "hideLoading", "popperAppendToBody", "highlightFirstItem", "displayOnly"]),
  setup: function setup(props2, context) {
    return _setup({
      props: props2,
      context,
      renderless,
      api
    });
  }
});
var render = function render2() {
  var _vm = this;
  var _h = _vm.$createElement;
  var _c = _vm._self._c || _h;
  return _c("div", {
    directives: [{
      name: "clickoutside",
      rawName: "v-clickoutside",
      value: _vm.close,
      expression: "close"
    }],
    staticClass: "xm-autocomplete",
    attrs: {
      "aria-haspopup": "listbox",
      "role": "combobox",
      "aria-expanded": _vm.state.suggestionVisible,
      "aria-owns": _vm.state.id
    }
  }, [_c("xm-input", _vm._b({
    ref: "input",
    attrs: {
      "tabindex": _vm.tabindex,
      "display-only": _vm.displayOnly
    },
    on: {
      "update:modelValue": _vm.handleChange,
      "focus": _vm.handleFocus,
      "blur": _vm.handleBlur,
      "clear": _vm.handleClear,
      "keydown": [function($event) {
        if (!$event.type.indexOf("key") && _vm._k($event.keyCode, "up", 38, $event.key, ["Up", "ArrowUp"]))
          return null;
        $event.preventDefault();
        return _vm.highlight(_vm.state.highlightedIndex - 1);
      }, function($event) {
        if (!$event.type.indexOf("key") && _vm._k($event.keyCode, "down", 40, $event.key, ["Down", "ArrowDown"]))
          return null;
        $event.preventDefault();
        return _vm.highlight(_vm.state.highlightedIndex + 1);
      }, function($event) {
        if (!$event.type.indexOf("key") && _vm._k($event.keyCode, "enter", 13, $event.key, "Enter"))
          return null;
        return _vm.handleKeyEnter.apply(null, arguments);
      }, function($event) {
        if (!$event.type.indexOf("key") && _vm._k($event.keyCode, "tab", 9, $event.key, "Tab"))
          return null;
        return _vm.close.apply(null, arguments);
      }]
    },
    scopedSlots: _vm._u([_vm.slots.prepend ? {
      key: "prepend",
      fn: function fn() {
        return [_vm._t("prepend")];
      },
      proxy: true
    } : null, _vm.slots.append ? {
      key: "append",
      fn: function fn() {
        return [_vm._t("append")];
      },
      proxy: true
    } : null, _vm.slots.prefix ? {
      key: "prefix",
      fn: function fn() {
        return [_vm._t("prefix")];
      },
      proxy: true
    } : null, _vm.slots.suffix ? {
      key: "suffix",
      fn: function fn() {
        return [_vm._t("suffix")];
      },
      proxy: true
    } : null], null, true)
  }, "xm-input", _vm.f(_vm.$props, _vm.$attrs), false)), _c("transition", {
    attrs: {
      "name": "xm-zoom-in-top"
    },
    on: {
      "after-leave": _vm.doDestroy
    }
  }, [_c("div", {
    directives: [{
      name: "show",
      rawName: "v-show",
      value: _vm.suggestionState.showPopper,
      expression: "suggestionState.showPopper"
    }],
    ref: "popper",
    staticClass: "xm-autocomplete xm-autocomplete-suggestion xm-popper",
    class: [_vm.popperClass ? _vm.popperClass : "", {
      "is-loading": !_vm.hideLoading && _vm.state.loading
    }],
    style: {
      width: _vm.suggestionState.dropdownWidth
    },
    attrs: {
      "role": "region"
    }
  }, [_c("xm-scrollbar", {
    attrs: {
      "tag": "ul",
      "wrap-class": "xm-autocomplete-suggestion__wrap",
      "view-class": "xm-autocomplete-suggestion__list",
      "margin-bottom-adjust": 6
    }
  }, [!_vm.hideLoading && _vm.state.loading ? _c("li", {
    staticClass: "xm-autocomplete-suggestion__list-loading"
  }, [_c("icon-loading", {
    attrs: {
      "width": "1em",
      "height": "1em"
    }
  })], 1) : _vm._l(_vm.state.suggestions, function(item, index) {
    return _c("li", {
      key: index,
      staticClass: "xm-autocomplete-suggestion__list-item",
      class: {
        highlighted: _vm.state.highlightedIndex === index
      },
      attrs: {
        "id": _vm.state.id + "-item-" + index,
        "role": "option",
        "aria-selected": _vm.state.highlightedIndex === index
      },
      on: {
        "click": function click($event) {
          return _vm.select(item);
        }
      }
    }, [_vm._t("default", function() {
      return [_vm._v(" " + _vm._s(item[_vm.valueKey]) + " ")];
    }, {
      "slotScope": item
    })], 2);
  })], 2)], 1)])], 1);
};
var staticRenderFns = [];
var __cssModules = {};
var __component__ = /* @__PURE__ */ normalizeComponent(__vue2_script, render, staticRenderFns, false, __vue2_injectStyles, null, null, null);
function __vue2_injectStyles(context) {
  for (var o in __cssModules) {
    this[o] = __cssModules[o];
  }
}
var pc = /* @__PURE__ */ function() {
  return __component__.exports;
}();
export {
  pc as default
};
